<div class="d-flex justify-content-center mt-5">
  <div class="col-12 col-md-10 mt-4 px-4">
    <ng-container *transloco="let t; prefix: 'administration'">

      <div class="row" id="detailFields">
        @if (!loading()) {
          <div class="row text-break" id="emailTitle">
            <h1 class="text-primary">{{ requestDetail.applicant.email }}</h1>
          </div>
          <div class="col-lg-3 col-md-6 col-12 ">
            <div class="row pb-1">
              <div class="col fw-semibold fieldTitle">
                {{ t('status') }}
              </div>
            </div>
            <div class="row pb-3">
              <div class="col">
                <span id="statusFieldBadge" class="badge fieldContent"
                      [ngClass]="{
                    'bg-info': requestDetail.status.value === 'IN_REVIEW',
                    'bg-danger': requestDetail.status.value === 'REJECTED',
                    'bg-success': requestDetail.status.value === 'APPROVED',
                    'bg-primary': requestDetail.status.value === 'IN_PROGRESS',
                   }"
                >
                  {{ requestDetail.status.label }}
                </span>
              </div>
            </div>
          </div>
          <div class="col-lg-3 col-md-6 col-12 text-break" *ngIf="requestDetail.rejectionCause">
            <div class="row pb-1">
              <div class="col fw-semibold fieldTitle">
                {{ t('rejectionCause') }}
              </div>
            </div>
            <div class="row pb-3">
              <div class="col fieldContent">
                {{ requestDetail.rejectionCause }}
              </div>
            </div>
          </div>
          <div class="col-lg-3 col-md-6 col-12 text-break">
            <div class="row pb-1">
              <div class="col fw-semibold fieldTitle">
                {{ t('email') }}
              </div>
            </div>
            <div class="row pb-3">
              <div class="col fieldContent">
                {{ requestDetail.applicant.email }}
              </div>
            </div>
          </div>
          <div class="col-lg-3 col-md-6 col-12 text-break">
            <div class="row pb-1">
              <div class="col fw-semibold fieldTitle">
                {{ t('participant') }}
              </div>
            </div>
            <div class="row pb-3">
              <div class="col fieldContent">
                {{ requestDetail.participantType.label }}
              </div>
            </div>
          </div>
          <div class="col-lg-3 col-md-6 col-12">
            <div class="row pb-1">
              <div class="col fw-semibold fieldTitle">
                {{ t('date') }}
              </div>
            </div>
            <div class="row pb-3">
              <div class="col fieldContent">
                {{ requestDetail.creationTimestamp | date }}
              </div>
            </div>
          </div>
          <div class="d-flex flex-row gap-2 mt-3" *ngIf="requestDetail.status.value  === 'IN_REVIEW' || requestDetail.status.value  === 'IN_PROGRESS'">
            <button mat-stroked-button color="accent" id="approveButton"
                    [disabled]="requestDetail.status.value  === 'IN_PROGRESS'"
                    (click)="openDialogApprove()">{{ t('approve') }}
            </button>
            <button mat-stroked-button color="warn" id="rejectButton"
                    [disabled]="requestDetail.status.value  === 'IN_PROGRESS'"
                    (click)="openDialogReject()">{{ t('reject') }}
            </button>
            <button mat-stroked-button [disabled]="requestDetail.status.value === 'IN_PROGRESS'" (click)="RequestRevision()">
              <mat-icon>update</mat-icon>
              {{ t('confirmNewDocument') }}
            </button>
          </div>
          <div class="mt-4">
            <lib-tabs [tabs]="tabs" (clickTab)="clickTab($event)"></lib-tabs>
          </div>
          <ng-container>
            @switch (tab()) {
              @case ('DOCUMENTS') {
                <ng-container>
                  <div class="mt-4 px-2">
                    <button class="w-8" type="button" color="accent" mat-flat-button [disabled]="requestDetail.status.value  === 'IN_PROGRESS' || requestDetail.status.value  === 'APPROVED' || requestDetail.status.value  === 'REJECTED'" (click)="requestNewDocument()">
                      {{ t('requestNewDocument') }}
                    </button>
                  </div>

                  @for (document of requestDetail.documents; track $index) {
                    <div class="row border border-1 border-black p-2 m-2 mt-4">
                      <div class="col-12">
                        @if (document.documentTemplate) {
                          <div>
                            {{ document.documentTemplate.description || 'No description' }}
                          </div>
                          <mat-chip-set class="my-2">
                            <mat-chip>{{ document.documentTemplate.mimeType.value || 'No description' }}</mat-chip>
                            <mat-chip>{{ document.documentTemplate.mandatory ? 'Mandatory' : 'Not mandatory' }}</mat-chip>
                          </mat-chip-set>
                        } @else {
                          <div>
                            {{ document.description || 'No description' }}
                          </div>
                          <mat-chip-set class="my-2">
                            <mat-chip>{{ document?.mimeType?.value || 'No description' }}</mat-chip>
                            <mat-chip>{{ document?.mandatory ? 'Mandatory' : 'Not mandatory'}}</mat-chip>
                          </mat-chip-set>
                        }
                        <div class="d-flex flex-row gap-1">
                          @if (document.hasContent) {
                            <button type="button" color="accent" mat-stroked-button (click)="downloadFile(document.id)">
                              <mat-icon>cloud_download</mat-icon>
                              {{ t('downloadFile') }}
                            </button>
                          } @else {
                            <div class="text-danger">
                              {{ t('notYetUpload') }}
                            </div>
                          }
                        </div>
                        <div class="d-flex flex-row gap-2 mt-2">
                          <span class="file-name">{{ document?.filename }}</span>
                          <span class="text-secondary" *ngIf="document?.filesize > 0">{{ '(' + document?.filesize / 1000  + 'Kb)' }}</span>
                          <span class="text-secondary" *ngIf="document?.hasContent">{{ t('lastUpdateFile') }}{{ document?.updateTimestamp | date }}</span>
                        </div>
                      </div>
                    </div>
                  }
                </ng-container>
              }
              @case ('COMMENTS') {
                @if (requestDetail) {
                  @if ((requestDetail.status.value === 'IN_PROGRESS' && roles.includes('APPLICANT'))
                  || (requestDetail.status.value === 'IN_REVIEW' && roles.includes('NOTARY'))) {
                    <lib-comments class="mt-4" labelComment="requestOnboarding.labelComment"
                                  buttonComment="requestOnboarding.buttonComment"
                                  emptyComment="requestOnboarding.emptyComment"
                                  commentAuthor="requestOnboarding.commentAuthor"
                                  (postComment)="sendPostComment($event)"
                                  [comments]="requestDetail.comments">
                    </lib-comments>
                  } @else {
                    <div class="mt-4">
                      @if (requestDetail.comments.length > 0) {
                        <div *ngFor="let comment of requestDetail.comments">
                          <h5>{{comment.content}}</h5>
                          <h6 class="text-secondary">
                            {{ t('commentAuthor', {
                            author: comment.author,
                            datePost: (comment.creationTimestamp ? comment.creationTimestamp : today.toString()) | toDate | date: 'mediumDate',
                            hours: (comment.creationTimestamp ? comment.creationTimestamp : today.toString()) | toDate | date: 'shortTime'
                          }) }}
                          </h6>
                        </div>
                      } @else {
                        <div>
                          <h5>{{t('commentEmpty')}}</h5>
                        </div>
                      }
                    </div>
                  }
                }
              }
              @case ('IDATTR') {
                @if (requestDetail.status.value !== 'REJECTED') {
                  <div class="row mt-4" id="identityAttributeTable">
                    @if (requestDetail.status.value !== 'APPROVED') {
                    <lib-search-page [checkboxToCheck]="checkboxToCheck" [disabledCheckbox]="requestDetail.status.value === 'IN_PROGRESS'" [pageInfo]="enabledIdentityAttributesTablepageInfo"
                                     [staticFilters]="{name: 'enabled', value: 'true'}"
                                     [offlinePaginator]="true"
                                     [allDataRow]="true"
                                     (checkboxSelectionEmitter)="onChangeCheckboxSelection($event)"></lib-search-page>
                    } @else {
                      @if (requestDetail.status.value === 'APPROVED') {
                        <table mat-table [dataSource]="dataSource">

                          <ng-container matColumnDef="id">
                            <th mat-header-cell *matHeaderCellDef>{{t('id') | uppercase}}</th>
                            <td mat-cell *matCellDef="let element"> {{element.id}} </td>
                          </ng-container>

                          <ng-container matColumnDef="code">
                            <th mat-header-cell *matHeaderCellDef> {{t('code') | uppercase}} </th>
                            <td mat-cell *matCellDef="let element"> {{element.code}} </td>
                          </ng-container>

                          <ng-container matColumnDef="assignableToRoles">
                            <th mat-header-cell *matHeaderCellDef> {{t('assignableToRoles') | uppercase}} </th>
                            <td mat-cell *matCellDef="let element"> {{element.assignableToRoles ? t('yes') : t('no')}} </td>
                          </ng-container>

                          <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                          <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
                        </table>
                      }
                    }
                  </div>
                } @else {
                  <div class="mt-4">
                    <h5>{{t('identityAttributeNoShow')}}</h5>
                  </div>
                }
              }
            }
          </ng-container>
        } @else {
          <div class="w-full d-flex items-center justify-content-center py-5">
            <lib-loader [size]=80></lib-loader>
          </div>
        }
      </div>
    </ng-container>
  </div>
</div>
